;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsm2.asm
;Author: IAO
;URL: 
;
;Description: To send bits for the Parallel Port.  
;
;Created:  14-08-2005 Esp. (Eng. 08-14-2005)
;Finished: 15-08-2005 Esp. (Eng. 08-15-2005)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

;************************************************************
;-Programa para enviar al LPT1 un valor y encender unos leds
;-Ya Funciona Bin.
;************************************************************

.386
.model flat,stdcall
option casemap:none

include LedAsm2.inc


.code
start:
        invoke LoadLibrary,addr DLLName
        .if eax==NULL
                invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
        .else
                mov hLib,eax
                invoke GetProcAddress,hLib,addr FunctionName
                .if eax==NULL
                        invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                .else

				mov SalidaAddr,eax
			
				call Salida 
				             
                .endif
                invoke FreeLibrary,hLib
        .endif
        invoke ExitProcess,NULL
                
Salida PROC, direccion:DWORD, valor:DWORD
	mov valor,15 ;255           ; put a number 
	push valor
	mov direccion,378h
	push direccion
	call [SalidaAddr]

    ret
Salida endp
                
end start

