;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsmG3.asm
;Author: IAO
;URL: 
;
;Description: To send bits for the Parallel Port.  
;
;Created:  01-07-2005 Esp. (Eng. 07-01-2005)
;Finished: 16-07-2005 Esp. (Eng. 07-16-2005)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 
;=================================================
;-Program to send value of 0 to 255 to LPT Port.
;-Two weeks of writing and it proves. Today 16-07-2005 this working. 
;-Programmed by IAO.
;-It is free in total form.  Make with it, how you want.
;-If you improve it, please send me modification. If you want. 
;=================================================
.386
.model flat,stdcall
option casemap:none

include LedAsmG3.inc

.code
start:
	invoke LoadDLL,hLib
	
	invoke GetModuleHandle, NULL
	mov hInstance,eax
	

	;LLama al Dialog Box almacenado en el .DLG o .RC
	invoke DialogBoxParam, hInstance, MyDialog, NULL, addr DlgProc, NULL
	invoke FreeLibrary,hLib
	invoke ExitProcess,eax

;========================================================================
DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
		
	.IF uMsg==WM_INITDIALOG

		;Esto es para el Icono.	
		invoke LoadIcon,hInstance,200
        mov hIcon, eax
        invoke SendMessage,hWnd,WM_SETICON,1,hIcon
	  	
		;Esto es para el Edit BOX. Contrtol Handles.
		invoke GetDlgItem, hWnd, IDC_EDIT
        mov hEdit1, eax

		;Probando la carga de un Procedimiento.
	  	invoke WndProc ,DWORD,DWORD,DWORD,DWORD

	;Para Cerrar el Programa
	.ELSEIF uMsg==WM_CLOSE
		invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

;========================================================================
	;Procesan los Men y Botones
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.IF lParam==0 ;Aqu Comprueba que lParam es un Men.
			.IF ax==IDM_GETTEXT
				invoke GetDlgItemText,hWnd,IDC_EDIT,ADDR buffer,512
				invoke MessageBox,NULL,ADDR buffer,ADDR AppName,MB_OK
			.ELSEIF ax==IDM_CLEAR
				invoke SetDlgItemText,hWnd,IDC_EDIT,NULL
				
				
			.ELSEIF ax==IDM_EXIT
				invoke EndDialog, hWnd, NULL
			.ENDIF
		.ELSE
			mov edx,wParam
			shr edx,16
			.if dx==BN_CLICKED
				.IF ax==IDC_BUTTON				
					invoke GetDlgItemInt, hWnd, IDC_EDIT, NULL, FALSE
					mov hEdit1,eax 

					;Si es mayor de 255 o Menor de cero esta fuera de valor
					.if (hEdit1 > 255 || hEdit1 < 0)
						invoke MessageBox,NULL,addr FueraDeValor,addr AppName,MB_OK
						jmp @F ;Salta si se cumple lo anterior, evitando P_out1
					.endif   

					invoke P_out1,DWORD,DWORD

					;Para que devuelva el foco al Edit Box.
					@@:
					;										;WM_SETFOCUS WM_SETTEXT EM_SETSEL
					invoke 	SendDlgItemMessage,hWnd,IDC_EDIT,EM_SETSEL,0,-1					
					invoke  GetDlgItem,hWnd,IDC_EDIT ;Le quite [hWnd]
					mov hEdit1, eax
					invoke  SetFocus,hEdit1  ;eax
					;				
                    .ELSEIF ax==IDC_EXIT
					invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0
					
				.ENDIF
			.ENDIF
		.ENDIF
	.ELSE
		mov eax,FALSE
		ret
	.ENDIF
	mov eax,TRUE
	ret
DlgProc endp

;========================================================================
LoadDLL PROC hLibrary:DWORD
;Carga de la DLL y Funcion
	  invoke LoadLibrary,addr DLLName
        .if eax==NULL
                invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
        	.else
                mov hLib,eax
                invoke GetProcAddress,hLib,addr FunctionName
                .if eax==NULL
                    invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
                .else
                mov OutAddr,eax     ;Carga el handle en OutAddr
                ;call P_out1        ; Get the addresses of the procedures
           .endif
	 .endif
;Final Carga DLL y Funcion Out32	
	
	ret
LoadDLL endp

;========================================================================
P_out1 PROC PortAddress:DWORD , data:DWORD
			
		mov eax,hEdit1
		mov data,eax
		push data
		mov  PortAddress,378h
		push PortAddress


 		;Puesto Aqui funciona.
		call [OutAddr]    ;Despliega el Contenido de TestAddr

		pop  PortAddress	
		pop  data
		
    ret
P_out1 endp

;========================================================================
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

      LOCAL TheValue     :DWORD     ; use LOCAL variable on the
      LOCAL inBuffer[64] :BYTE      ; stack as they are more
      LOCAL outBuffer[64]:BYTE      ; efficient with file size.

		
        ;----------------------------------------
        ;Subclass 1ero. uno para que el texto pueda filtrarse 
        ;----------------------------------------
        invoke SetWindowLong,hEdit1,GWL_WNDPROC,Edit1Proc
        mov lpfnEdit1Proc, eax
        
 
        invoke GetWindowText,hEdit1,ADDR inBuffer,40
        ;------------------------
        ;text is now in inBuffer, test if its blank.
        ;------------------------
        lea esi,inBuffer       ; get 1st byte
        lodsb
        cmp al,0               ; see if its ascii zero
        jne @F
          invoke SetFocus,hEdit1
          xor eax, eax          ; return zero if blank
          ret
        @@:

		;Convert text to DWORD value
        invoke atodw,ADDR inBuffer	;atodw esta dentro de masm32.inc y .lib   
        mov TheValue, eax
		
        ;-------------------------------------------------------------
        ;Do the function call here for the numeric conversion you need
        ;using the DWORD value converted from the text input. When it
        ;is done, use the following conversion of the result back to
        ;text and display it in the second edit control.
        ;-------------------------------------------------------------
        invoke wsprintf,ADDR outBuffer,ADDR fMtStrinG,TheValue

ret
WndProc endp

;========================================================================
Edit1Proc proc hCtl:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL tl:DWORD
    LOCAL testBuffer[16]:BYTE

  ; -----------------------------
  ; Process control messages here
  ; -----------------------------
    .if uMsg == WM_CHAR
      .if wParam == 8       ; allow backspace
        jmp @F              ; jump FORWORD to next @@:
      .endif


;Me Permite Escribir en el EditBox 
;Despus de 3 Nmeros
;--------------------------------------
	.elseif uMsg==WM_KEYDOWN 
		mov eax,wParam
		;;.if wParam == VK_RETURN
			;;invoke MessageBox,NULL,addr Message,addr AppName,MB_OK ;+MB_ICONINFORMATION		
			;;invoke SetFocus,hEdit1
		;;.else
   		;;invoke CallWindowProc,lpfnEdit1Proc,hCtl,uMsg,wParam,lParam
			ret
		;;.endif
;--------------------------------------

	
    invoke GetWindowText,hCtl,ADDR testBuffer,16

      	.if eax >= 3       ; restrict length to 3 digits
        	xor eax, eax
        	ret
      	.endif
      
      
    ; ------------------
    ; allow numbers only
    ; ------------------
      	.if wParam > 57		;9 en Decimal. 39h
          	xor eax, eax
          	ret
      	.elseif wParam < 48  	;0 en Decimal. 30h
          	xor eax, eax
          	ret
      	.endif         
    @@:

    .endif


    invoke CallWindowProc,lpfnEdit1Proc,hCtl,uMsg,wParam,lParam
    ret
Edit1Proc endp

;-------------------------------------------------------------------------
end start

