;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  EfecLED.asm
;Author: IAO
;URL: 
;
;Description: To send bits for the Parallel Port.  
;
;Created:  20-02-2006 Esp. (Eng. 02-20-2006)
;Finished: 21-02-2006 Esp. (Eng. 02-21-2006)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

;-Este es un programa algo rstico para enviar distintas secuancias 
;al puerto paralelo y asi  tener efectos con Leds.
;-Sacado de Internet: www.geocities.com/charlytospage. Modificado por: IAO.
;-Al apretar "q" o "ESC", sale del programa, no retorna al men.

;-Compilar con Masm.   ;Por tener Masm32 y Masm16. Cambi Link.exe por DosLnk.exe
;ML /c EfecLED.asm
;DosLnk EfecLED.obj,EfecLED.exe; 


.model small,c
.386
.stack

.data
Ver1 DB 'ESCRIBA EL NUMERO DEL EFECTO 0 a 4: ', '$'
Ver2 DB 13,10,'CARACTER INVALIDO..',13,10, '$'
Ver3 DB 13,10,'EFECTO EN PROCESO..', '$'

.code
.startup
MAIN 	PROC FAR
	MOV SI,OFFSET Demora
	MOV DX,378H			;DIRECCION DEL PUERTO PARALELO
	;MOV AX,CS
	;MOV DS,AX

	MOV AH,09H
	MOV DX, OFFSET Ver1
	INT 21H 
	MOV AH,1			;Funcin captacin carcter desde teclado
	MOV DL,0FFH			;Entrada por la consola
	INT 21H 				;LEE EL CARACTER DEL TECLADO

	CMP AL,30H 			;Es un 0 Decimal
	JE EFA				;Efecto A
	CMP AL,31H 			;Es un 1 Decimal
	JE EFB				;Efecto B
	CMP AL,32H 			;Es un 2 Decimal
	JE EFC				;Efecto C
	CMP AL,33H 			;Es un 3 Decimal
	JE EFD				;Efecto D
	CMP AL,34H 			;Es un 4 Decimal
	JE EFE				;Efecto E
	CMP AL,71H 			;Es "q" ASSCI 
	JE	ADIOS			;Sale del Programa.

ERROR1:
    MOV AH,09H
  	MOV DX,OFFSET Ver2
  	INT 21H
  	JMP MAIN
  
EFA:					;Cuando Selecciono 0
 	MOV AL,0H
 	MOV DX,378H			;DIRECCION DEL PUERTO PARALELO
 	OUT DX,AL
 	CALL SI
 	MOV AL,11111111B
 	OUT DX,AL
 	CALL SI
 	JMP EFA
 
EFB:					;Cuando Selecciono 1
 	MOV DX,0378H			;DIRECCION DEL PUERTO PARALELO
	MOV AL,01010101b
	OUT DX,AL
 	CALL SI
 	MOV AL,10101010b
 	OUT DX,AL
 	CALL SI
 	JMP EFB
 
EFC: 					;Cuando Selecciono	2	
					;(Lee desde el teclado y Muestra valor en LPT)
	MOV AH,1
 	MOV DL,0FFH
 	INT 21H 				;LEE EL CARACTER DEL TECLADO
 	MOV DX,378H			;DIRECCION DEL PUERTO PARALELO
 	OUT DX,AL

 	MOV AH,03H			;Funcin captacin carcter desde teclado
 	CMP AL,1Bh 			;Es la Tecla "ESC"
 	JE  ADIOS

 	JMP EFC
 
EFD:					;Cuando Selecciono 3
 	MOV AX,00001111b  ;1111111100000000B ;
  AQUI:
 	MOV DX,378H			;DIRECCION DEL PUERTO PARALEL
 	OUT DX,AL
 	PUSH AX
 	CALL SI
 	POP AX
 	ROL AX,1
 	JMP AQUI
 
EFE: 					;Cuando Selecciono 4
 	MOV AX,1000000010000000B
  AQUI1:
 	MOV DX,378H			;DIRECCION DEL PUERTO PARALEL
 	OUT DX,AL
 	PUSH AX
 	CALL SI
 	POP AX
 	ROL AX,1
 	JMP AQUI1

MAIN ENDP


Demora 	proc near
	MOV BX,00F0H
DEM1:
 	MOV CX,0111111111111111B
DEM2:
	MOV AH,09H
 	MOV DX, OFFSET Ver3
 	INT 21H  ;51H
 	DEC BX
 	JZ FIN
 	JMP DEM1
 
FIN: 
;Check for keystroke
 	MOV AH,06H			;Funcin copiar carcter con eco
 	MOV DL,0FFH			;Entrada por la consola
 	INT 21H 				;LEE EL CARACTER DEL TECLADO
	JZ  Sigue

;Get keystroke from keyboard:
 	MOV AH,03H			;Funcin captacin carcter desde teclado
 	CMP AL,1Bh 			;Es la Tecla "ESC"
 	JE  ADIOS
	INT 21h
	
Sigue:
 	MOV DX,378H 			;DIRECCION DEL PUERTO PARALELO 
; 	jmp MAIN
	RET
Demora   ENDP

ADIOS:
;	MOV AH,4CH        \ No Hace falta porque tiene (.exit)
;	INT 21H		/
.exit			 		;Salida del Programa.

END 