;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;Title:  LedAsm.asm
;Author: IAO
;URL: 
;
;Description: To send bits for the Parallel Port.   
;
;Created:  20-03-2006 Esp. (Eng. 03-20-2006)
;Finished: 21-03-2006 Esp. (Eng. 03-21-2006)
;Modified:  
;Email: rdpt465@yahoo.es
;Trabajando bin. (Working well)
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 
;
;-Completo y Funcionando.
;-Programa para escribir en LPT1 e incremente el valor de los leds. 
;-Aqui manda el valor por la INT 21 Funcion 05
;-Salir del Programa con: "Ctrl C".
;
;-Compilar con Masm. Por tener Masm32 y Masm16. Cambi Link.exe por DosLnk.exe
;ML /c LedAsm.asm
;DosLnk /tiny LedAsm.obj,LedAsm.com;

.model tiny
.data

org 100h
.code 
.startup
MOV AL,1

next_situation:
MOV AH,05       	;Funcion para la INT 21h Escribir  un caracter en la impresora
MOV DL,AL	;Sin esto no trabaja bin
int 21h		;Servicio de DOS valor hexadecimal

ROL AL, 1    	; rotate bit.
CALL Delay 
JMP next_situation

;Rutina Delay 
Delay:	MOV	BX,8000 	;Con este valor 8000 trabaja bien el retardo
AQUI:	MOV	CX,8000	
LOOP1:	DEC	CX		
	OR	CX,0
	JNZ	LOOP1
	DEC	BX
	JNZ	AQUI
	RET
.exit 
END

